From 9026ec591d25d58346d51706d487392372cd2374 Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Sun, 22 May 2022 23:45:27 +0100
Subject: [PATCH 01/21] Remove pyspotify: playlists and tracks

---
 mopidy_spotify/backend.py   | 131 +---------
 mopidy_spotify/browse.py    |   6 +-
 mopidy_spotify/library.py   |   2 +-
 mopidy_spotify/lookup.py    |  35 +--
 mopidy_spotify/playback.py  | 266 --------------------
 mopidy_spotify/playlists.py |  21 +-
 mopidy_spotify/web.py       |  16 ++
 tests/conftest.py           |   1 -
 tests/test_backend.py       | 265 ++------------------
 tests/test_playback.py      | 474 +-----------------------------------
 tests/test_playlists.py     |  79 +-----
 11 files changed, 85 insertions(+), 1211 deletions(-)
 delete mode 100644 mopidy_spotify/playback.py

diff --git a/mopidy_spotify/backend.py b/mopidy_spotify/backend.py
index 7cefb489..59a6a467 100644
--- a/mopidy_spotify/backend.py
+++ b/mopidy_spotify/backend.py
@@ -6,39 +6,24 @@
 from mopidy import backend, httpclient
 
 import spotify
-from mopidy_spotify import Extension, library, playback, playlists, web
+from mopidy_spotify import Extension, library, playlists, web
 
 logger = logging.getLogger(__name__)
 
 
-BITRATES = {
-    96: spotify.Bitrate.BITRATE_96k,
-    160: spotify.Bitrate.BITRATE_160k,
-    320: spotify.Bitrate.BITRATE_320k,
-}
-
-
 class SpotifyBackend(pykka.ThreadingActor, backend.Backend):
 
-    _logged_in = threading.Event()
-    _logged_out = threading.Event()
-    _logged_out.set()
-
     def __init__(self, config, audio):
         super().__init__()
 
         self._config = config
         self._audio = audio
         self._actor_proxy = None
-        self._session = None
-        self._event_loop = None
-        self._bitrate = None
+        self._bitrate = config["spotify"]["bitrate"]
         self._web_client = None
 
         self.library = library.SpotifyLibraryProvider(backend=self)
-        self.playback = playback.SpotifyPlaybackProvider(
-            audio=audio, backend=self
-        )
+        self.playback = SpotifyPlaybackProvider(audio=audio, backend=self)
         if config["spotify"]["allow_playlists"]:
             self.playlists = playlists.SpotifyPlaylistsProvider(backend=self)
         else:
@@ -47,15 +32,6 @@ def __init__(self, config, audio):
 
     def on_start(self):
         self._actor_proxy = self.actor_ref.proxy()
-        self._session = self._get_session(self._config)
-
-        self._event_loop = spotify.EventLoop(self._session)
-        self._event_loop.start()
-
-        self._session.login(
-            self._config["spotify"]["username"],
-            self._config["spotify"]["password"],
-        )
 
         self._web_client = web.SpotifyOAuthClient(
             client_id=self._config["spotify"]["client_id"],
@@ -67,99 +43,8 @@ def on_start(self):
         if self.playlists is not None:
             self.playlists.refresh()
 
-    def on_stop(self):
-        logger.debug("Logging out of Spotify")
-        self._session.logout()
-        self._logged_out.wait()
-        self._event_loop.stop()
-
-    def _get_session(self, config):
-        session = spotify.Session(self._get_spotify_config(config))
-
-        session.connection.allow_network = config["spotify"]["allow_network"]
-
-        self._bitrate = config["spotify"]["bitrate"]
-        session.preferred_bitrate = BITRATES[self._bitrate]
-        session.volume_normalization = config["spotify"]["volume_normalization"]
-
-        backend_actor_proxy = self._actor_proxy
-        session.on(
-            spotify.SessionEvent.CONNECTION_STATE_UPDATED,
-            on_connection_state_changed,
-            self._logged_in,
-            self._logged_out,
-            backend_actor_proxy,
-        )
-        session.on(
-            spotify.SessionEvent.PLAY_TOKEN_LOST,
-            on_play_token_lost,
-            backend_actor_proxy,
-        )
-
-        return session
-
-    def _get_spotify_config(self, config):
-        ext = Extension()
-        spotify_config = spotify.Config()
-
-        spotify_config.load_application_key_file(
-            pathlib.Path(__file__).parent / "spotify_appkey.key"
-        )
-
-        if config["spotify"]["allow_cache"]:
-            spotify_config.cache_location = bytes(ext.get_cache_dir(config))
-        else:
-            spotify_config.cache_location = None
-
-        spotify_config.settings_location = bytes(ext.get_data_dir(config))
-
-        proxy_uri = httpclient.format_proxy(config["proxy"], auth=False)
-        if proxy_uri is not None:
-            logger.debug(f"Connecting to Spotify through proxy: {proxy_uri}")
-
-        spotify_config.proxy = proxy_uri
-        spotify_config.proxy_username = config["proxy"].get("username")
-        spotify_config.proxy_password = config["proxy"].get("password")
-
-        return spotify_config
-
-    def on_logged_in(self):
-        if self._config["spotify"]["private_session"]:
-            logger.info("Spotify private session activated")
-            self._session.social.private_session = True
-
-    def on_play_token_lost(self):
-        if self._session.player.state == spotify.PlayerState.PLAYING:
-            self.playback.pause()
-            logger.warning(
-                "Spotify has been paused because your account is "
-                "being used somewhere else."
-            )
-
-
-def on_connection_state_changed(
-    session, logged_in_event, logged_out_event, backend
-):
-
-    # Called from the pyspotify event loop, and not in an actor context.
-    if session.connection.state is spotify.ConnectionState.LOGGED_OUT:
-        logger.debug("Logged out of Spotify")
-        logged_in_event.clear()
-        logged_out_event.set()
-    elif session.connection.state is spotify.ConnectionState.LOGGED_IN:
-        logger.info("Logged in to Spotify in online mode")
-        logged_in_event.set()
-        logged_out_event.clear()
-        backend.on_logged_in()
-    elif session.connection.state is spotify.ConnectionState.DISCONNECTED:
-        logger.info("Disconnected from Spotify")
-    elif session.connection.state is spotify.ConnectionState.OFFLINE:
-        logger.info("Logged in to Spotify in offline mode")
-        logged_in_event.set()
-        logged_out_event.clear()
-
-
-def on_play_token_lost(session, backend):
-    # Called from the pyspotify event loop, and not in an actor context.
-    logger.debug("Spotify play token lost")
-    backend.on_play_token_lost()
+class SpotifyPlaybackProvider(backend.PlaybackProvider):
+    def translate_uri(self, uri):
+        username = self.backend._config["spotify"]["username"]
+        password = self.backend._config["spotify"]["password"]
+        return f"{uri}?username={username}&password={password}"
diff --git a/mopidy_spotify/browse.py b/mopidy_spotify/browse.py
index 749360d7..d8f31690 100644
--- a/mopidy_spotify/browse.py
+++ b/mopidy_spotify/browse.py
@@ -57,7 +57,7 @@ def browse(*, config, session, web_client, uri):
     elif uri == _PLAYLISTS_DIR.uri:
         return _PLAYLISTS_DIR_CONTENTS
     elif uri.startswith("spotify:user:") or uri.startswith("spotify:playlist:"):
-        return _browse_playlist(session, web_client, uri, config)
+        return _browse_playlist(web_client, uri, config)
     elif uri.startswith("spotify:album:"):
         return _browse_album(session, uri, config)
     elif uri.startswith("spotify:artist:"):
@@ -88,9 +88,9 @@ def browse(*, config, session, web_client, uri):
     return []
 
 
-def _browse_playlist(session, web_client, uri, config):
+def _browse_playlist(web_client, uri, config):
     return playlists.playlist_lookup(
-        session, web_client, uri, config["bitrate"], as_items=True
+        web_client, uri, config["bitrate"], as_items=True
     )
 
 
diff --git a/mopidy_spotify/library.py b/mopidy_spotify/library.py
index d62e3da2..b08ff0c3 100644
--- a/mopidy_spotify/library.py
+++ b/mopidy_spotify/library.py
@@ -17,7 +17,7 @@ def __init__(self, backend):
     def browse(self, uri):
         return browse.browse(
             config=self._config,
-            session=self._backend._session,
+            session=None, # TODO
             web_client=self._backend._web_client,
             uri=uri,
         )
diff --git a/mopidy_spotify/lookup.py b/mopidy_spotify/lookup.py
index c36f0159..085d2e18 100644
--- a/mopidy_spotify/lookup.py
+++ b/mopidy_spotify/lookup.py
@@ -12,29 +12,30 @@
 
 
 def lookup(config, session, web_client, uri):
+    if web_client is None or not web_client.logged_in:
+        return []
+
     try:
         web_link = WebLink.from_uri(uri)
-        if web_link.type not in (LinkType.PLAYLIST, LinkType.YOUR):
-            sp_link = session.get_link(uri)
     except ValueError as exc:
         logger.info(f"Failed to lookup {uri!r}: {exc}")
         return []
 
     try:
         if web_link.type == LinkType.PLAYLIST:
-            return _lookup_playlist(config, session, web_client, uri)
+            return _lookup_playlist(config, web_client, uri)
         elif web_link.type == LinkType.YOUR:
             return list(_lookup_your(config, session, web_client, uri))
-        elif sp_link.type is spotify.LinkType.TRACK:
-            return list(_lookup_track(config, sp_link))
-        elif sp_link.type is spotify.LinkType.ALBUM:
+        elif web_link.type == LinkType.TRACK:
+            return list(_lookup_track(config, web_client, uri))
+        elif web_link.type == LinkType.ALBUM:
             return list(_lookup_album(config, sp_link))
-        elif sp_link.type is spotify.LinkType.ARTIST:
+        elif web_link.type == LinkType.ARTIST:
             with utils.time_logger("Artist lookup"):
                 return list(_lookup_artist(config, sp_link))
         else:
             logger.info(
-                f"Failed to lookup {uri!r}: Cannot handle {sp_link.type!r}"
+                f"Failed to lookup {uri!r}: Cannot handle {web_link.type!r}"
             )
             return []
     except spotify.Error as exc:
@@ -42,10 +43,14 @@ def lookup(config, session, web_client, uri):
         return []
 
 
-def _lookup_track(config, sp_link):
-    sp_track = sp_link.as_track()
-    sp_track.load(config["timeout"])
-    track = translator.to_track(sp_track, bitrate=config["bitrate"])
+def _lookup_track(config, web_client, uri):
+    web_track = web_client.get_track(uri)
+
+    if web_track == {}:
+        logger.error(f"Failed to lookup Spotify track URI {uri!r}")
+        return
+
+    track = translator.web_to_track(web_track, bitrate=config["bitrate"])
     if track is not None:
         yield track
 
@@ -88,10 +93,8 @@ def _lookup_artist(config, sp_link):
                 yield track
 
 
-def _lookup_playlist(config, session, web_client, uri):
-    playlist = playlists.playlist_lookup(
-        session, web_client, uri, config["bitrate"]
-    )
+def _lookup_playlist(config, web_client, uri):
+    playlist = playlists.playlist_lookup(web_client, uri, config["bitrate"])
     if playlist is None:
         raise spotify.Error("Playlist Web API lookup failed")
     return playlist.tracks
diff --git a/mopidy_spotify/playlists.py b/mopidy_spotify/playlists.py
index 5811d9e1..09b83c1e 100644
--- a/mopidy_spotify/playlists.py
+++ b/mopidy_spotify/playlists.py
@@ -5,7 +5,6 @@
 import spotify
 from mopidy_spotify import translator, utils
 
-_sp_links = {}
 
 logger = logging.getLogger(__name__)
 
@@ -42,7 +41,6 @@ def lookup(self, uri):
 
     def _get_playlist(self, uri, as_items=False):
         return playlist_lookup(
-            self._backend._session,
             self._backend._web_client,
             uri,
             self._backend._bitrate,
@@ -56,7 +54,6 @@ def refresh(self):
         logger.info("Refreshing Spotify playlists")
 
         with utils.time_logger("playlists.refresh()", logging.DEBUG):
-            _sp_links.clear()
             self._backend._web_client.clear_cache()
             count = 0
             for playlist_ref in self._get_flattened_playlist_refs():
@@ -76,7 +73,7 @@ def save(self, playlist):
         pass  # TODO
 
 
-def playlist_lookup(session, web_client, uri, bitrate, as_items=False):
+def playlist_lookup(web_client, uri, bitrate, as_items=False):
     if web_client is None or not web_client.logged_in:
         return
 
@@ -93,22 +90,8 @@ def playlist_lookup(session, web_client, uri, bitrate, as_items=False):
         bitrate=bitrate,
         as_items=as_items,
     )
+    #TODO: cache the Mopidy tracks? And handle as_items here instead of translator
     if playlist is None:
         return
-    # Store the libspotify Link for each track so they will be loaded in the
-    # background ready for using later.
-    if session.connection.state is spotify.ConnectionState.LOGGED_IN:
-        if as_items:
-            tracks = playlist
-        else:
-            tracks = playlist.tracks
-
-        for track in tracks:
-            if track.uri in _sp_links:
-                continue
-            try:
-                _sp_links[track.uri] = session.get_link(track.uri)
-            except ValueError as exc:
-                logger.info(f"Failed to get link {track.uri!r}: {exc}")
 
     return playlist
diff --git a/mopidy_spotify/web.py b/mopidy_spotify/web.py
index b85eaaab..d67a6382 100644
--- a/mopidy_spotify/web.py
+++ b/mopidy_spotify/web.py
@@ -476,6 +476,22 @@ def get_playlist(self, uri):
 
         return playlist
 
+    def get_track(self, uri):
+        try:
+            parsed = WebLink.from_uri(uri)
+            if parsed.type != LinkType.TRACK:
+                raise ValueError(
+                    f"Could not parse {uri!r} as a Spotify track URI"
+                )
+        except ValueError as exc:
+            logger.error(exc)
+            return {}
+
+        return self.get_one(
+            f"tracks/{parsed.id}",
+            params={"market": "from_token"}
+        )
+
     def clear_cache(self, extra_expiry=None):
         self._cache.clear()
 
diff --git a/tests/conftest.py b/tests/conftest.py
index f49d576f..a37fef2b 100644
--- a/tests/conftest.py
+++ b/tests/conftest.py
@@ -423,5 +423,4 @@ def backend_listener_mock():
 
 @pytest.fixture
 def provider(backend_mock):
-    playlists._sp_links.clear()
     return library.SpotifyLibraryProvider(backend_mock)
diff --git a/tests/test_backend.py b/tests/test_backend.py
index bcf04bb2..68ecc48b 100644
--- a/tests/test_backend.py
+++ b/tests/test_backend.py
@@ -1,43 +1,39 @@
 import threading
 from unittest import mock
+from unittest import skip
 
 from mopidy import backend as backend_api
 
-import spotify
-from mopidy_spotify import backend, library, playback, playlists
+from mopidy_spotify import backend, library, playlists
+from mopidy_spotify.backend import SpotifyPlaybackProvider
 
 
-def get_backend(config, session_mock=None):
+def get_backend(config):
     obj = backend.SpotifyBackend(config=config, audio=None)
-    if session_mock:
-        obj._session = session_mock
-    else:
-        obj._session = mock.Mock()
-        obj._web_client = mock.Mock()
-    obj._event_loop = mock.Mock()
+    obj._web_client = mock.Mock()
     return obj
 
 
-def test_uri_schemes(spotify_mock, config):
+def test_uri_schemes(config):
     backend = get_backend(config)
 
     assert "spotify" in backend.uri_schemes
 
 
-def test_init_sets_up_the_providers(spotify_mock, config):
+def test_init_sets_up_the_providers(config):
     backend = get_backend(config)
 
     assert isinstance(backend.library, library.SpotifyLibraryProvider)
     assert isinstance(backend.library, backend_api.LibraryProvider)
 
-    assert isinstance(backend.playback, playback.SpotifyPlaybackProvider)
+    assert isinstance(backend.playback, SpotifyPlaybackProvider)
     assert isinstance(backend.playback, backend_api.PlaybackProvider)
 
     assert isinstance(backend.playlists, playlists.SpotifyPlaylistsProvider)
     assert isinstance(backend.playlists, backend_api.PlaylistsProvider)
 
 
-def test_init_disables_playlists_provider_if_not_allowed(spotify_mock, config):
+def test_init_disables_playlists_provider_if_not_allowed(config):
     config["spotify"]["allow_playlists"] = False
 
     backend = get_backend(config)
@@ -45,60 +41,24 @@ def test_init_disables_playlists_provider_if_not_allowed(spotify_mock, config):
     assert backend.playlists is None
 
 
-def test_on_start_creates_configured_session(tmp_path, spotify_mock, config):
+@skip("support this with spotifyaudiosrc")
+def test_on_start_creates_configured_session(tmp_path, config):
     cache_location_mock = mock.PropertyMock()
-    settings_location_mock = mock.PropertyMock()
-    config_mock = spotify_mock.Config.return_value
-    type(config_mock).cache_location = cache_location_mock
-    type(config_mock).settings_location = settings_location_mock
+    pass
 
-    get_backend(config).on_start()
 
-    spotify_mock.Config.assert_called_once_with()
-    config_mock.load_application_key_file.assert_called_once_with(mock.ANY)
-    cache_location_mock.assert_called_once_with(
-        bytes(tmp_path / "cache" / "spotify")
-    )
-    settings_location_mock.assert_called_once_with(
-        bytes(tmp_path / "data" / "spotify")
-    )
-    spotify_mock.Session.assert_called_once_with(config_mock)
-
-
-def test_on_start_disallows_network_if_config_is_set(spotify_mock, config):
-    session = spotify_mock.Session.return_value
-    allow_network_mock = mock.PropertyMock()
-    type(session.connection).allow_network = allow_network_mock
-    config["spotify"]["allow_network"] = False
-
-    get_backend(config).on_start()
-
-    allow_network_mock.assert_called_once_with(False)
-
-
-def test_on_start_configures_preferred_bitrate(spotify_mock, config):
-    session = spotify_mock.Session.return_value
-    preferred_bitrate_mock = mock.PropertyMock()
-    type(session).preferred_bitrate = preferred_bitrate_mock
-    config["spotify"]["bitrate"] = 320
-
-    get_backend(config).on_start()
-
-    preferred_bitrate_mock.assert_called_once_with(spotify.Bitrate.BITRATE_320k)
+@skip("currently can't configure this")
+def test_on_start_configures_preferred_bitrate(config):
+    pass
 
 
-def test_on_start_configures_volume_normalization(spotify_mock, config):
-    session = spotify_mock.Session.return_value
-    volume_normalization_mock = mock.PropertyMock()
-    type(session).volume_normalization = volume_normalization_mock
-    config["spotify"]["volume_normalization"] = False
+@skip("support this with spotifyaudiosrc?")
+def test_on_start_configures_volume_normalization(config):
+    pass
 
-    get_backend(config).on_start()
 
-    volume_normalization_mock.assert_called_once_with(False)
-
-
-def test_on_start_configures_proxy(spotify_mock, web_mock, config):
+@skip("support this with spotifyaudiosrc?")
+def test_on_start_configures_proxy(web_mock, config):
     config["proxy"] = {
         "scheme": "https",
         "hostname": "my-proxy.example.com",
@@ -106,14 +66,10 @@ def test_on_start_configures_proxy(spotify_mock, web_mock, config):
         "username": "alice",
         "password": "s3cret",
     }
-    spotify_config = spotify_mock.Config.return_value
-
     backend = get_backend(config)
     backend.on_start()
 
-    assert spotify_config.proxy == "https://my-proxy.example.com:8080"
-    assert spotify_config.proxy_username == "alice"
-    assert spotify_config.proxy_password == "s3cret"
+    assert True
 
     web_mock.SpotifyOAuthClient.assert_called_once_with(
         client_id=mock.ANY,
@@ -122,7 +78,7 @@ def test_on_start_configures_proxy(spotify_mock, web_mock, config):
     )
 
 
-def test_on_start_configures_web_client(spotify_mock, web_mock, config):
+def test_on_start_configures_web_client(web_mock, config):
     config["spotify"]["client_id"] = "1234567"
     config["spotify"]["client_secret"] = "AbCdEfG"
 
@@ -136,54 +92,14 @@ def test_on_start_configures_web_client(spotify_mock, web_mock, config):
     )
 
 
-def test_on_start_adds_connection_state_changed_handler_to_session(
-    spotify_mock, config
-):
-    session = spotify_mock.Session.return_value
-
-    get_backend(config).on_start()
-
-    session.on.assert_any_call(
-        spotify_mock.SessionEvent.CONNECTION_STATE_UPDATED,
-        backend.on_connection_state_changed,
-        backend.SpotifyBackend._logged_in,
-        backend.SpotifyBackend._logged_out,
-        mock.ANY,
-    )
-
-
-def test_on_start_adds_play_token_lost_handler_to_session(spotify_mock, config):
-    session = spotify_mock.Session.return_value
-
-    obj = get_backend(config)
-    obj.on_start()
-
-    session.on.assert_any_call(
-        spotify_mock.SessionEvent.PLAY_TOKEN_LOST,
-        backend.on_play_token_lost,
-        mock.ANY,
-    )
-
-
-def test_on_start_starts_the_pyspotify_event_loop(spotify_mock, config):
-    backend = get_backend(config)
-    backend.on_start()
-
-    spotify_mock.EventLoop.assert_called_once_with(backend._session)
-    spotify_mock.EventLoop.return_value.start.assert_called_once_with()
-
-
-def test_on_start_logs_in(spotify_mock, web_mock, config):
+def test_on_start_logs_in(web_mock, config):
     backend = get_backend(config)
     backend.on_start()
 
-    spotify_mock.Session.return_value.login.assert_called_once_with(
-        "alice", "password"
-    )
     web_mock.SpotifyOAuthClient.return_value.login.assert_called_once()
 
 
-def test_on_start_refreshes_playlists(spotify_mock, web_mock, config, caplog):
+def test_on_start_refreshes_playlists(web_mock, config, caplog):
     backend = get_backend(config)
     backend.on_start()
 
@@ -194,7 +110,7 @@ def test_on_start_refreshes_playlists(spotify_mock, web_mock, config, caplog):
 
 
 def test_on_start_doesnt_refresh_playlists_if_not_allowed(
-    spotify_mock, web_mock, config, caplog
+    web_mock, config, caplog
 ):
     config["spotify"]["allow_playlists"] = False
 
@@ -204,134 +120,3 @@ def test_on_start_doesnt_refresh_playlists_if_not_allowed(
     client_mock = web_mock.SpotifyOAuthClient.return_value
     client_mock.get_user_playlists.assert_not_called()
     assert "Refreshed 0 playlists" not in caplog.text
-
-
-def test_on_stop_logs_out_and_waits_for_logout_to_complete(
-    spotify_mock, config, caplog
-):
-    backend = get_backend(config)
-    backend._logged_out = mock.Mock()
-
-    backend.on_stop()
-
-    assert "Logging out of Spotify" in caplog.text
-    backend._session.logout.assert_called_once_with()
-    backend._logged_out.wait.assert_called_once_with()
-    backend._event_loop.stop.assert_called_once_with()
-
-
-def test_on_connection_state_changed_when_logged_out(spotify_mock, caplog):
-    session_mock = spotify_mock.Session.return_value
-    session_mock.connection.state = spotify_mock.ConnectionState.LOGGED_OUT
-    logged_in_event = threading.Event()
-    logged_out_event = threading.Event()
-    actor_mock = mock.Mock(spec=backend.SpotifyBackend)
-
-    backend.on_connection_state_changed(
-        session_mock, logged_in_event, logged_out_event, actor_mock
-    )
-
-    assert "Logged out of Spotify" in caplog.text
-    assert not logged_in_event.is_set()
-    assert logged_out_event.is_set()
-
-
-def test_on_connection_state_changed_when_logged_in(spotify_mock, caplog):
-    session_mock = spotify_mock.Session.return_value
-    session_mock.connection.state = spotify_mock.ConnectionState.LOGGED_IN
-    logged_in_event = threading.Event()
-    logged_out_event = threading.Event()
-    actor_mock = mock.Mock(spec=backend.SpotifyBackend)
-
-    backend.on_connection_state_changed(
-        session_mock, logged_in_event, logged_out_event, actor_mock
-    )
-
-    assert "Logged in to Spotify in online mode" in caplog.text
-    assert logged_in_event.is_set()
-    assert not logged_out_event.is_set()
-    actor_mock.on_logged_in.assert_called_once_with()
-
-
-def test_on_connection_state_changed_when_disconnected(spotify_mock, caplog):
-    session_mock = spotify_mock.Session.return_value
-    session_mock.connection.state = spotify_mock.ConnectionState.DISCONNECTED
-    logged_in_event = threading.Event()
-    logged_out_event = threading.Event()
-    actor_mock = mock.Mock(spec=backend.SpotifyBackend)
-
-    backend.on_connection_state_changed(
-        session_mock, logged_in_event, logged_out_event, actor_mock
-    )
-
-    assert "Disconnected from Spotify" in caplog.text
-
-
-def test_on_connection_state_changed_when_offline(spotify_mock, caplog):
-    session_mock = spotify_mock.Session.return_value
-    session_mock.connection.state = spotify_mock.ConnectionState.OFFLINE
-    logged_in_event = threading.Event()
-    logged_out_event = threading.Event()
-    actor_mock = mock.Mock(spec=backend.SpotifyBackend)
-
-    backend.on_connection_state_changed(
-        session_mock, logged_in_event, logged_out_event, actor_mock
-    )
-
-    assert "Logged in to Spotify in offline mode" in caplog.text
-    assert logged_in_event.is_set()
-    assert not logged_out_event.is_set()
-
-
-def test_on_logged_in_event_activates_private_session(
-    spotify_mock, config, caplog
-):
-    session_mock = spotify_mock.Session.return_value
-    private_session_mock = mock.PropertyMock()
-    type(session_mock.social).private_session = private_session_mock
-    config["spotify"]["private_session"] = True
-    backend = get_backend(config, session_mock)
-
-    backend.on_logged_in()
-
-    assert "Spotify private session activated" in caplog.text
-    private_session_mock.assert_called_once_with(True)
-
-
-def test_on_play_token_lost_messages_the_actor(spotify_mock, caplog):
-    session_mock = spotify_mock.Session.return_value
-    actor_mock = mock.Mock(spec=backend.SpotifyBackend)
-
-    backend.on_play_token_lost(session_mock, actor_mock)
-
-    assert "Spotify play token lost" in caplog.text
-    actor_mock.on_play_token_lost.assert_called_once_with()
-
-
-def test_on_play_token_lost_event_when_playing(spotify_mock, config, caplog):
-    session_mock = spotify_mock.Session.return_value
-    session_mock.player.state = spotify_mock.PlayerState.PLAYING
-    backend = get_backend(config, session_mock)
-    backend.playback = mock.Mock(spec=playback.SpotifyPlaybackProvider)
-
-    backend.on_play_token_lost()
-
-    assert (
-        "Spotify has been paused because your account is "
-        "being used somewhere else." in caplog.text
-    )
-    backend.playback.pause.assert_called_once_with()
-
-
-def test_on_play_token_lost_event_when_not_playing(
-    spotify_mock, config, caplog
-):
-    session_mock = spotify_mock.Session.return_value
-    session_mock.player.state = spotify_mock.PlayerState.UNLOADED
-    backend = get_backend(config, session_mock)
-    backend.playback = mock.Mock(spec=playback.SpotifyPlaybackProvider)
-
-    backend.on_play_token_lost()
-
-    assert "Spotify has been paused" not in caplog.text
-    assert backend.playback.pause.call_count == 0
